#include "LocBra.h"
#include "LocBra1.h"

int setup_cplex()
{
   int status = 0;

   if (prec) {
      status += CPXsetdblparam(env, CPX_PARAM_EPAGAP, 1e-12);
      status += CPXsetdblparam(env, CPX_PARAM_EPGAP, 1e-06);
   } else status += CPXsetdblparam(env, CPX_PARAM_EPAGAP, 1e-06);

   status += CPXsetintparam(env, CPX_PARAM_SCRIND, video);
   status += CPXsetintparam(env, CPX_PARAM_MIPINTERVAL, mipInt);
   status += CPXsetintparam(env, CPX_PARAM_HEURFREQ, heurFreq);
   switch(emphasis) {
   case -1:
	   status += CPXsetintparam(env, CPX_PARAM_MIPEMPHASIS, 0);
	   break;
   case  0:
	   status += CPXsetintparam(env, CPX_PARAM_MIPEMPHASIS, 2);
	   break;
   case  1:
	   status += CPXsetintparam(env, CPX_PARAM_MIPEMPHASIS, 1);
	   break;
   }
   status += CPXsetintparam(env, CPX_PARAM_PREIND, presolve);

   return(status);
}

void wdummysol(double *initial) 
{
     int    surplus, storespace, j, status;
     char   *ctype;
     char   **name;
     char   *namestore;
     FILE   *out;

     storespace = 100 * ncols;

     name = (char**)calloc(ncols+1, sizeof(char*));
     namestore = (char*)calloc(storespace, sizeof(char));

     status = CPXgetcolname(env, lp, name, namestore, storespace, &surplus, 0, ncols-1);
     if (surplus < 0) {
        printf("\n insufficient store space!");
        printf("\n cols = %d, status = %d, surplus = %d", ncols, status, surplus);
	fflush(NULL);
     }

     ctype = (char*)calloc(ncols, sizeof(char));
     status = CPXgetctype(env, lp, ctype, 0, ncols - 1);

     out = fopen("solution.mst","w");
     fprintf(out, "NAME\n");
     for (j = 0; j < ncols; j++) if (ctype[j] != 'C') fprintf(out, "   %s %5.1f\n", name[j], initial[j]);
     fprintf(out, "ENDATA\n");
     fclose(out); fflush(out);

     free(ctype); free(name); free(namestore);
}
